﻿#Überwacht die Sicherung der Server
#Schickt ein Mail mit den Ergebnissen der Sicherung
#Thorsten Jarz

$ServerListe="srv01,srv02"
$Betreff="Sicherung der Server"
$Empfaenger="empfaenger1@meinschule.at,empfaenger2@meinschule.at"
$Sender="sicherung@meineschule.at"
$Username="maildienst@meienschule.at"; $Password="Kennwort" 
$SMTPServer="smtp.office365.com"; $SSL="True"; $Port=587

$datum = Get-Date
$servers =  $ServerListe -split  ","
$results = (1..$servers.length)

for ($i=0; $i -lt $servers.length; $i++)
	{
		$ConnectionError=0
		Write-Host "Frage Server ab: " $servers[$i]
		try{
			$Session = New-PSSession -ComputerName $servers[$i]
			$WindowsVersion = Invoke-Command -session $session -ScriptBlock {(Get-WmiObject win32_operatingsystem).version}
			if ($WindowsVersion -match "6.1")
				{$WBSummary = Invoke-Command -session $session -ScriptBlock {add-pssnapin windows.serverbackup;Get-WBSummary}}
			else 
				{$WBSummary = Invoke-Command -session $session -ScriptBlock {Get-WBSummary}}
			Remove-PSSession $Session
			}
		catch
			{Write-Host "Fehler bei der Abfrage des Servers"
			 Write-host "Type: $($_.Exception.GetType().FullName) `n Meldung: $($_.Exception.Message)" -ForegroundColor Red 
			 $ConnectionError=1
			}
			 
		
		$results[$i] = New-Object Collections.Arraylist
		
		$results[$i].add("<td>" + $servers[$i] + "</td>") > $null

		if ($ConnectionError -eq 1)
			{
			 $results[$i].add("<td><b><font color=red>Unknown</font></b></td>") > $null
			 $results[$i].add("<td>" + "Unknown" + "</td>") > $null
			 $results[$i].add("<td>" + "Fehler bei der Abfrage" + "</td>") > $null
			 $results[$i].add("<td>" + "Unknown" + "</td>") > $null
			 $results[$i].add("<td>" + "Unknown" + "</td>") > $null
			}
		else
			{
			 if ($WBSummary.LastBackupResultHR -eq 0) {$results[$i].add("<td><b><font color=green>Erfolg</font></b></td>") > $null;$result="Erfolg"}
			 else {$results[$i].add("<td><b><font color=red>Fehler</font></b></td>") > $null;$result="Fehler"}

			 if ($WBSummary.LastSuccessfulBackupTime -lt $datum.adddays(-1)) {$results[$i].add("<td><font color=red>" + $WBSummary.LastSuccessfulBackupTime + "</font></td>") > $null}  
			 else {$results[$i].add("<td><font color=green>" + $WBSummary.LastSuccessfulBackupTime + "</font></td>") > $null}
   
			 if ([string]::IsNullOrEmpty($WBSummary.DetailedMessage)){$results[$i].add("<td>Erfolg</td>") > $null}
			 else{$results[$i].add("<td>" + $WBSummary.DetailedMessage + "</td>") > $null}

			 $results[$i].add("<td>" + $WBSummary.NumberOfVersions + "</td>") > $null

			 if ([string]::IsNullOrEmpty($WBSummary.LastBackupTarget)){$results[$i].add("<td>keines</td>") > $null}
			 else{$results[$i].add("<td>" + $WBSummary.LastBackupTarget + "</td>") > $null}             
			 Write-Host "Letzes Backup Ergebnis: $result `n"
			}
	}

if ([boolean](get-variable "rows" -ErrorAction SilentlyContinue))
	{Clear-Variable -Name "rows" -Scope Global}

for ($i=0; $i -lt $servers.length; $i++)
	{$rows=$rows +"<tr>" + $results[$i] + "</tr>"}

$HTMLFile = @"
<html>
<head>
<style>TABLE{border-width: 1px;border-style: solid;border-collapse: collapse} TH{border-width: 2px;padding: 5px;border-style: solid}
	TD{border-width: 2px;padding: 5px;border-style: solid}</style>
</head>
<body>
<H1> $Betreff </H1>
<table>
	<tr>
		<th>Server</th>
		<th>Letzes Backup Ergebnis</th><th>Ende letztes Backup</th><th>Meldung</th>
		<th>Anzahl Backups</th><th>Backup Ziel</th>
	</tr>
		$rows
</table>
</body>
</html>
"@

# Email  
if($SMTPServer -ne "None")
	{$msg = new-object Net.Mail.MailMessage
	$smtp = new-object Net.Mail.SmtpClient($SMTPServer,$Port)
		
	$msg.From = $Sender
	$msg.ReplyTo = $Sender
	ForEach($mail in $Empfaenger)
	{
		$msg.To.Add($mail)
	}
	if ($Username -ne "None" -and $Password -ne "None")
	{
		$cred = new-object System.Net.NetworkCredential
		$cred.UserName =  $Username; $cred.Password = $Password
		$smtp.Credentials = $cred
	}
	if ($SSL -ne "False")
		{ $smtp.EnableSsl = $true }
	$msg.subject = $Betreff
	$msg.body = $HTMLFile
	$msg.IsBodyHtml = $true
	try{
		Write-Output "Sende E-mail" 
		$smtp.Send($msg) 
	   }
	catch{
		Write-Host "Fehler beim Senden" -ForegroundColor Red
		write-host "Type: $($_.Exception.GetType().FullName) `n Meldung: $($_.Exception.Message)" -ForegroundColor Red 
		}
	}